# module ERB::Util

### Constants

HTML_ESCAPE
JSON_ESCAPE

### Public Class Methods

h(s) click to toggle source
Alias for: html_escape
html_escape(s) click to toggle source

A utility method for escaping HTML tag characters. This method is also aliased as `h`.

In your ERB templates, use this method to escape any unsafe content. For example:

    <%=h @person.name %>

#### Example:

    puts html_escape("is a > 0 & a < 10?")
    # => is a &gt; 0 &amp; a &lt; 10?

    # File lib/active_support/core_ext/string/output_safety.rb, line 20
    def html_escape(s)
      s = s.to_s
      if s.html_safe?
        s
      else
        s.encode(s.encoding, :xml => :attr)[1...-1].html_safe
      end
    end

Also aliased as: h
j(s) click to toggle source
Alias for: json_escape
json_escape(s) click to toggle source

A utility method for escaping HTML entities in JSON strings using uXXXX JavaScript escape sequences for string literals:

    json_escape("is a > 0 & a < 10?")
    # => is a \u003E 0 \u0026 a \u003C 10?

Note that after this operation is performed the output is not valid JSON. In particular double quotes are removed:

    json_escape('{"name":"john","created_at":"2010-04-28T01:39:31Z","id":1}')
    # => {name:john,created_at:2010-04-28T01:39:31Z,id:1}

This method is also aliased as `j`, and available as a helper in Rails templates:

    <%=j @person.to_json %>

    # File lib/active_support/core_ext/string/output_safety.rb, line 65
    def json_escape(s)
      result = s.to_s.gsub(%r[&"><]/) { |special| JSON_ESCAPE[special] }
      s.html_safe? ? result.html_safe : result
    end

Also aliased as: j